"""
Module to get list of all relay nodes present in the network
:author; gurnoorsingh (20221110)
"""
import re
import json

LOG_FILE = "/home/azureuser/node/data/node.archive.log"

relay_nodes = set()
relay_node_endpoints = set()

with open(LOG_FILE) as fh:
    for line in fh.readlines():
        if re.match(".*OutgoingPeers", line):
            dict_obj = json.loads(line)
            for peer in dict_obj['details']['OutgoingPeers']:
                relay_nodes.add(peer['Address'])
                relay_node_endpoints.add(peer['Endpoint'])

print(len(relay_nodes))
print(relay_nodes)

print(len(relay_node_endpoints))
print(relay_node_endpoints)