"""
Module to process log file for received messages from relays
:author: gurnoorsingh (20221024)
"""
import os
import re
import json
from collections import defaultdict
from RTT import RTT

BASE_DIR = "/home/azureuser/node/data"
FILENAME = "node.log"

MSG_RECEIVED_IDENTIFIER = "got a tx group with IDs"

tx_senders_map = defaultdict(lambda: [])
relay_set = set()

with open(os.path.join(BASE_DIR, FILENAME)) as fh:
    for line in fh.readlines():
        try:
            row = json.loads(line)
        except:
            continue
        if row["msg"].startswith(MSG_RECEIVED_IDENTIFIER):
            txn_ids_str = re.findall(f".*{MSG_RECEIVED_IDENTIFIER} \[(.*?)\].*", row["msg"])[0]
            txn_ids = [x.strip() for x in txn_ids_str.split()]
            sender = re.findall(".*rootURL:(.*?)\s.*", row["msg"])[0]
            recv_time = int(re.findall(".*at.*?([0-9]+).*", row["msg"])[0])
            txn_size = len(re.findall(".*uint8=\[(.*?)\]", row["msg"])[0].split())

            # add sender and received time to txn sender map
            for txn in txn_ids:
                tx_senders_map[txn].append((sender, recv_time, txn_size))

            # add sender address to set of relays
            relay_set.add(sender)            


TXN_ID = "UCPRQGVTATHIFUEUX3ZVJC3FK2W4YLTDOFXEW563ZCAGNLMBZ5HQ"
send_times = []
for k, v in tx_senders_map.items():
    if k == TXN_ID:
        for sender, recv_time in v:
            send_time = recv_time - RTT(f"http://{sender}")//2
            print(f"Received time: {recv_time}\nSend time: {send_time}")
            send_times.append((sender, send_time))

send_times.sort(key=lambda x: x[1])
print(send_times)
